apiVersion: "sparkoperator.k8s.io/v1beta2"
kind: SparkApplication
metadata:
  name: job-name
  namespace: spark-jobs
spec:
  type: Python
  pythonVersion: "3"
  mode: cluster
  image: registry.gitlab.com/calincs/conversion/reconciliation-spark-image/master:latest
  imagePullPolicy: Always
  mainApplicationFile: s3a://users/recon-api/prod/app/main.py
  arguments:
    - "job_id"
    - "target_kg"
    - "input_format"
    - "match_number"
    - "match_threshold"
    - "S3_data_path"
    - "S3_authority_path"
  sparkVersion: "3.1.1"
  # restartPolicy:
  #   type: OnFailure
  #   onFailureRetries: 3
  #   onFailureRetryInterval: 10
  #   onSubmissionFailureRetries: 5
  #   onSubmissionFailureRetryInterval: 20
  executor:
    # number of pods to spawn
    instances: 6
    # number of cores per pod
    cores: 8
    # memory request for each pod
    memory: "32G"
    ephemeral-storage: "1G"
  driver:
    # Splits up the job into tasks and schedules them. Coordinates results.
    cores: 2
    memory: "2G"
    serviceAccount: spark-operator-spark
    env:
      - name: AWS_ACCESS_KEY_ID
        valueFrom:
          secretKeyRef:
            name: aws-secrets
            key: aws-access-key
      - name: AWS_SECRET_ACCESS_KEY
        valueFrom:
          secretKeyRef:
            name: aws-secrets
            key: aws-secret-key   
  sparkConf:
    spark.hadoop.fs.s3a.impl: org.apache.hadoop.fs.s3a.S3AFileSystem
    spark.hadoop.fs.s3a.endpoint: https://aux.lincsproject.ca
    spark.hadoop.fs.s3a.path.style.access: "true"
    spark.eventLog.enabled: "true"
    spark.eventLog.dir: s3a://spark-hs/log
    spark.driver.extraClassPath: local:///opt/spark/work-dir/scala-udf-similarity-0.0.9.jar
    spark.driver.extraClassPath: org.apache.hadoop:hadoop-aws:3.3.2
    spark.driver.extraClassPath: com.amazonaws:aws-java-sdk-bundle:1.11.1026
    spark.driver.extraClassPath: local:///opt/spark/work-dir/graphframes-0.8.0-spark3.0-s_2.12.jar
    spark.executor.extraClassPath: local:///opt/spark/work-dir/scala-udf-similarity-0.0.9.jar
    spark.executor.extraClassPath: org.apache.hadoop:hadoop-aws:3.3.2
    spark.executor.extraClassPath: com.amazonaws:aws-java-sdk-bundle:1.11.1026
    spark.executor.extraClassPath: local:///opt/spark/work-dir/graphframes-0.8.0-spark3.0-s_2.12.jar
  deps:
    jars:
      - local:///opt/spark/work-dir/scala-udf-similarity-0.0.9.jar
    pyFiles:
      - local:///opt/spark/work-dir/python/app/link.py
      - local:///opt/spark/work-dir/python/app/blocking.py
      - local:///opt/spark/work-dir/python/app/normalize_data.py
      - local:///opt/spark/work-dir/python/app/settings.py
      - local:///opt/spark/work-dir/python/app/utils.py
